#uses "fwUnitTestComponentAsserts.ctl"

#uses "test/fwRPC/utils.ctl"

#uses "CtrlSerialization"

#uses "fwRPC/fwRPC_server.ctl"
#uses "fwRPC/fwRPC_requestModel.ctl"
#uses "fwRPC/fwRPC_functionModel.ctl"

// Setup
//------------------------------------------------------------------------------

void test_fwRPC_server_setupSuite() {
  _BEGIN_SUITE("server");
  _setup_deleteDp();
}

void test_fwRPC_server_teardownSuite() {
  _setup_deleteDp();
  _END_SUITE();
}

void test_fwRPC_server_setup() {
  _BEGIN_TEST();
}

void test_fwRPC_server_teardown() {
}

void _setup_deleteDp() {
  if (dpExists(_dp)) {
    dpDelete(_dp);
  }
}


// Mock / utils
//------------------------------------------------------------------------------
const string _func = "func";
const string _stub = "stub";
const string _lib = "lib";
const dyn_int _param = makeDynInt(INT_VAR);
const bool _exclusive = true;
const string _dp = "_FwRPC_Function/func";

const string _id = "1234";
const string _result = "result";


// Tests
//------------------------------------------------------------------------------

void test_fwRPC_server_registersFunction() {
  _setup_deleteDp();

  string func, stub, lib;
  dyn_int param;
  bool exc;

  fwRPC_registerFunction(_func, _stub, _lib, -1, _param, _exclusive);

  assertTrue(dpExists(_dp));
  dpGet(
    _dp + fwRPC_FUNCTION_DPE_NAME, func,
    _dp + fwRPC_FUNCTION_DPE_STUB, stub,
    _dp + fwRPC_FUNCTION_DPE_LIBFILE, lib,
    _dp + fwRPC_FUNCTION_DPE_PARAMTYPE, param,
    _dp + fwRPC_FUNCTION_DPE_EXCLUSIVE, exc
  );

  assertEqual(_func, func);
  assertEqual(_stub, stub);
  assertEqual(_lib, lib);
  assertEqual(_param, param);
  assertEqual(_exclusive, exc);
}

void test_fwRPC_server_buildsSuccessfulResult() {
  dyn_mixed obj = fwRPC_makeResult(_id, true, _result);
  
  assertEqual(_id, obj[fwRPC_RESULT_HDL]);
  assertEqual(fwRPC_REQUEST_STATUS_DONE, obj[fwRPC_RESULT_STATUS]);
  assertEqual(_result, obj[fwRPC_RESULT_VALUE]);
}


void test_fwRPC_server_buildsErrorResult() {
  dyn_mixed obj = fwRPC_makeResult(_id, false, _result);

  assertEqual(_id, obj[fwRPC_RESULT_HDL]);
  assertEqual(fwRPC_REQUEST_STATUS_ERROR, obj[fwRPC_RESULT_STATUS]);
  assertEqual(_result, obj[fwRPC_RESULT_VALUE]);
}
