#uses "fwViewer/fwViewer_documentOpener.ctl"
#uses "fwUnitTestComponentAsserts.ctl"
class testFwViewer_documentOpener : fwViewer_documentOpener {
	private string getPdfFile(string url) {
		string path = "myFilePath";
		return path;
	}
};

void test_isPdfFile_returnTrue() {
	string url = "http://www.pdf995.com/samples/test.pdf";
	fwViewer_documentOpener systemUnderTest = fwViewer_documentOpener();
	assertTrue(systemUnderTest.isPdfFile(url));
}

void test_isPdfFile_returnFalse() {
	string url = "http://www.pdf995.com/samples/test.doc";
	fwViewer_documentOpener systemUnderTest = fwViewer_documentOpener();
	assertFalse(systemUnderTest.isPdfFile(url));
}

void test_getPageNumber_returnFileName() {
	string url;
	int expectedPageNumber;
	fwViewer_documentOpener systemUnderTest = fwViewer_documentOpener();
	
	url = "http://www.pdf995.com/samples/test.pdf";
	expectedPageNumber = 1;
	int pageNumber = systemUnderTest.getPageNumber(url);
	assertEqual(expectedPageNumber,pageNumber);
	
	url = "https://edms.cern.ch/file/1302367/last_released/Analyse_Fonctionelle_UW65_new_docx_cpdf.pdf?page=104&pagemode=bookmarks";
	expectedPageNumber = 104;
	int pageNumber = systemUnderTest.getPageNumber(url);
	assertEqual(expectedPageNumber,pageNumber);	
	
	url = "https://edms.cern.ch/file/1302367/last_released/Analyse_Fonctionelle_UW65_new_docx_cpdf.pdf?page=33";
	expectedPageNumber = 33;
	int pageNumber = systemUnderTest.getPageNumber(url);
	assertEqual(expectedPageNumber,pageNumber);	
}

void test_getPdfFile_returnPath() {
	string url = "http://www.pdf995.com/samples/test.pdf";
	testFwViewer_documentOpener systemUnderTest = testFwViewer_documentOpener();
	string expectedFilePath = "myFilePath";
	string filePath = systemUnderTest.getPdfFilePath(url);
	assertEqual(expectedFilePath, filePath);
}